import "DigitalUtopia.Palantir";
import "DigitalUtopia.DUInterface";
import "DigitalUtopia.Utilsx";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
--import "DigitalUtopia.Utilsx.Class";



CheckBox = class( Turbine.UI.Control );
function CheckBox:Constructor()
	Turbine.UI.Control.Constructor( self );
	self.checkBox = Turbine.UI.Control();
	self.checkBox:SetParent(self);
	self.checkBox:SetSize(16,16);
	self.checkBox:SetPosition(234,0);
	self.checkBox:SetZOrder(20);
	self.checkBox:SetBlendMode(7);
	self.IsChecked = false;
	self.checkStr="_empty";
	self.IsDisabled = false;
	self.disStr=""
	self.boxSize=2; 
	self:SetSize(250,16);
	self.title=Turbine.UI.Label();
	self.title:SetParent(self);
	self:SetBackColor(Turbine.UI.Color(.9,0,0,0));
	self.title:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.title:SetFontStyle(Turbine.UI.FontStyle.None );
	self.title:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.title:SetText("Awesome Box");
	self.title:SetSize(230,16)
	self.title:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	
	function self:updateBG()
		self.bgStr = "DigitalUtopia/DUInterface/Resources/checkbox_0"..self.boxSize;
		if(self.checkStr~=nil)then
			self.bgStr=self.bgStr..self.checkStr;
		end
		if(self.disStr~=nil)then
			self.bgStr=self.bgStr..self.disStr;
		end
		self.bgStr=self.bgStr..".tga";
		self.checkBox:SetBackground(self.bgStr);
	end
	self:updateBG();
	
	
	function self:SetDisabled(dis)
		if (dis==true)then
			self.IsDisabled=true;
			self.disStr="_ghosted";
			self:updateBG();
		else
			self.IsDisabled=false;
			self.disStr="";
			self:updateBG();
		end
	end
	
	function self:GetDisabled()
		return self.IsDisabled;
	end
	
	function self:SetChecked(chk)
		if (chk == true)then
			
	  	self.IsChecked = true
	  	self.checkStr="";
	  	self:updateBG();
	  else
	  	self.IsChecked = false
	  	self.checkStr="_empty";
	  	self:updateBG();
	  end
	end
	
	function self:SetText(text)
		self.title:SetText(text)
	end
	
	function self:GetText(text)
		return self.title:GetText();
	end
	function self:GetChecked()
		return self.IsChecked;
	end
	
	self.CheckChanged=function()
	
	end
	
	self.checkBox.MouseClick = function(sender,args)
	if(self.IsDisabled==false)then
		if(self.IsChecked==false)then
			self:SetChecked(true);
			self.CheckChanged()
		else
			self:SetChecked(false);
			self.CheckChanged()
	  	
		end
	end
end
end