import "DigitalUtopia.DUInterface";
import "DigitalUtopia.Utilsx";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
--import "DigitalUtopia.Utilsx.Class";

SetupWindow = class(DigitalUtopia.DUInterface.Window );

function SetupWindow:Constructor()
	DigitalUtopia.DUInterface.Window.Constructor( self,575,534 );
	self.tbHolder:SetWidth(255);
	self.tbRight:SetPosition(self.tbHolder:GetWidth()-35,0)
	self.tbHolder:SetLeft((self:GetWidth() - self.tbHolder:GetWidth())/2);
	self.tbCenter:SetSize(self.tbHolder:GetWidth()-70,42);
	self.tbCenter:SetPosition(self.tbLeft:GetLeft()+35,0)
	self.bg:SetSize(503,462);
	self.text:SetText("Palantir Options");
	self.text:SetWidth(self.tbHolder:GetWidth());
	self.text:SetHeight(20);
	self.text:SetLeft(-35);
	self.text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.clButton:SetPosition(self:GetWidth()-23,24)
	self.tw=Turbine.UI.Window();
	self.tw:SetParent(self);
	self.tw:SetSize(575,534);
	self.tw:SetPosition(0,0);
	self.tw:SetMouseVisible(false);
	
	

	self.sb = Turbine.UI.Lotro.ScrollBar();
	self.sb:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.sb:SetParent(self.tw);
	self.sb:SetPosition(422,50);
	self.sb:SetSize(10,448);
	self.sb:SetZOrder(10);
	self.sb:SetBackColorBlendMode(0);
	self.sb:SetBlendMode(0);
	self.sp=Turbine.UI.ListBox();
	self.sp:SetParent(self.tw);
	self.sp:SetPosition(12,50);
	--self.sp:SetBackColor(Turbine.UI.Color(1,0,0));
	self.sp:SetSize(420,448);
	self.sp:SetVerticalScrollBar(self.sb);
	--self.sp:SetVisible(false);
	self.sp:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.sp:SetMaxItemsPerLine(1);
	self.sp:SetBackColorBlendMode(0);
	self.sp:SetBlendMode(4);
	
	self.revMain=Turbine.UI.Lotro.Button();
	self.revMain:SetParent(self.tw);
	self.revMain:SetSize(128,20);
	self.revMain:SetText("Revert Main");
	self.revMain:SetPosition(32,500);
	self.revMain:SetEnabled(false);
	
	self.defMain=Turbine.UI.Lotro.Button();
	self.defMain:SetParent(self.tw);
	self.defMain:SetSize(128,20);
	self.defMain:SetText("Default Main");
	self.defMain:SetPosition(163,500);
	
	self.accMain=Turbine.UI.Lotro.Button();
	self.accMain:SetParent(self.tw);
	self.accMain:SetSize(128,20);
	self.accMain:SetText("Accept");
	self.accMain:SetPosition(294,500);
	
	self.hdr = Header();
	self.hdr.SetText("Misc.");
	--self.hdr:SetParent(self.tw);
	--self.hdr:SetPosition(30,60);
	self.sp:AddItem(self.hdr);
	self.sicHolder=Turbine.UI.Control();
	self.sicHolder:SetSize(420,30);
	
	self.showincombat = DigitalUtopia.DUInterface.CheckBox();
	self.showincombat:SetChecked(true);
	self.showincombat:SetText("Show Only In Combat");
	self.showincombat:SetParent(self.sicHolder);
	self.showincombat:SetLeft(155);
	self.sp:AddItem(self.sicHolder); 
	
	
	
	self.nocHolder=Turbine.UI.Control();
	self.nocHolder:SetSize(420,30);
	
	self.noc = DigitalUtopia.DUInterface.DropDownBox({"Vitals 100%","Morale 100%","Power 100%","Out of Combat"});
	self.noc:SetParent(self.nocHolder);
	self.noc:SetPosition(246,0);
	self.nocPanel = Turbine.UI.Window();
	self.nocPanel:SetParent(self.sp);
	self.nocPanel:SetPosition(0,0);
	self.nocPanel:SetSize(480,448);
	self.nocPanel:SetZOrder(99);
	self.nocPanel:SetVisible(false);
	self.nocLb = self.noc.listBox; 
	self.nocLb:SetParent(self.nocPanel);
	self.nocLb:SetZOrder(99);
	self.nocLb:SetBlendMode(0);
	self.nocLb:SetBackColorBlendMode(0);
	self.nocLb:SetPosition(200,200);
	self.nocLabel=Turbine.UI.Label();
	self.nocLabel:SetParent(self.nocHolder);
	self.nocLabel:SetPosition(0,0);
	self.nocLabel:SetSize(246,20);
	self.nocLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.nocLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.nocLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.nocLabel:SetText("Out Of Combat Criteria");
	self.sp:AddItem(self.nocHolder);
	
	self.svHolder=Turbine.UI.Control();
	self.svHolder:SetSize(420,30);
	
	self.sv = DigitalUtopia.DUInterface.CheckBox();
	self.sv:SetChecked(true);
	self.sv:SetText("Show Game Vitals");
	self.sv:SetParent(self.svHolder);
	self.sv:SetLeft(155);
	self.sp:AddItem(self.svHolder); 
	
	self.acHolder=Turbine.UI.Control();
	self.acHolder:SetSize(420,30);
	
	self.ac = DigitalUtopia.DUInterface.DropDownBox({"Account","Character","Server"});
	self.ac:SetParent(self.acHolder);
	self.ac:SetPosition(246,0);
	self.acPanel = Turbine.UI.Window();
	self.acPanel:SetParent(self.sp);
	self.acPanel:SetPosition(0,0);
	self.acPanel:SetSize(480,448);
	self.acPanel:SetZOrder(99);
	self.acPanel:SetVisible(false);
	self.acLb = self.ac.listBox; 
	self.acLb:SetParent(self.acPanel);
	self.acLb:SetZOrder(99);
	self.acLb:SetBlendMode(0);
	self.acLb:SetBackColorBlendMode(0);
	self.acLb:SetPosition(200,200);
	self.acLabel=Turbine.UI.Label();
	self.acLabel:SetParent(self.acHolder);
	self.acLabel:SetPosition(0,0);
	self.acLabel:SetSize(246,20);
	self.acLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.acLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.acLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.acLabel:SetText("Settings Scope");
	self.sp:AddItem(self.acHolder);

	self.vitHdr=Header();
	self.vitHdr.SetText("Player Vitals");
	self.sp:AddItem(self.vitHdr);
	
	self.voHolder = Turbine.UI.Control();
	self.voHolder:SetSize(420,45);

	self.voSld = DigitalUtopia.DUInterface.Slider();
	self.voSld:SetParent(self.voHolder);
	self.voSld:SetLeft(57);
	self.voSld:SetText("Bar Opacity");
	self.sp:AddItem(self.voHolder);
	
	self.bpHolder = Turbine.UI.Control();
	self.bpHolder:SetSize(420,45);

	self.bpSld = DigitalUtopia.DUInterface.Slider();
	self.bpSld:SetParent(self.bpHolder);
	self.bpSld:SetLeft(57);
	self.bpSld:SetText("Bar Spacing");
	self.sp:AddItem(self.bpHolder);
	
	self.txHolder = Turbine.UI.Control();
	self.txHolder:SetSize(420,45);

	self.txSld = DigitalUtopia.DUInterface.Slider();
	self.txSld:SetParent(self.txHolder);
	self.txSld:SetLeft(57);
	self.txSld:SetText("Text Opacity");
	self.sp:AddItem(self.txHolder);
	
	self.dbHdr=Header();
	self.dbHdr.SetText("Debuff Bar");
	self.sp:AddItem(self.dbHdr);

	self.sdbHolder=Turbine.UI.Window();
	self.sdbHolder:SetSize(420,30);
	
	self.sdb = DigitalUtopia.DUInterface.CheckBox();
	self.sdb:SetChecked(true);
	self.sdb:SetText("Show Debuff Bar");
	self.sdb:SetParent(self.sdbHolder);
	self.sdb:SetLeft(155);
	self.sp:AddItem(self.sdbHolder); 	
	
	self.debuffDisplayHolder=Turbine.UI.Control();
	self.debuffDisplayHolder:SetSize(420,30);
	
	self.debuffDisplay = DigitalUtopia.DUInterface.DropDownBox({"Indicators Only","Curable Support"});
	self.debuffDisplay:SetParent(self.debuffDisplayHolder);
	self.debuffDisplay:SetPosition(246,0);
	self.debuffDisplayPanel = Turbine.UI.Window();
	self.debuffDisplayPanel:SetParent(self.sp);
	self.debuffDisplayPanel:SetPosition(0,0);
	self.debuffDisplayPanel:SetSize(480,448);
	self.debuffDisplayPanel:SetZOrder(99);
	self.debuffDisplayPanel:SetVisible(false);
	self.debuffDisplayLb = self.debuffDisplay.listBox; 
	self.debuffDisplayLb:SetParent(self.debuffDisplayPanel);
	self.debuffDisplayLb:SetZOrder(99);
	self.debuffDisplayLb:SetBlendMode(0);
	self.debuffDisplayLb:SetBackColorBlendMode(0);
	self.debuffDisplayLb:SetPosition(200,200);
	self.debuffDisplayLabel=Turbine.UI.Label();
	self.debuffDisplayLabel:SetParent(self.debuffDisplayHolder);
	self.debuffDisplayLabel:SetPosition(0,0);
	self.debuffDisplayLabel:SetSize(246,20);
	self.debuffDisplayLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.debuffDisplayLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.debuffDisplayLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.debuffDisplayLabel:SetText("Display Mode");
	self.sp:AddItem(self.debuffDisplayHolder);
	
		self.debuffDisplayPanel.MouseClick=function(sender,args)
		self.debuffDisplay.Close();
		self.debuffDisplayPanel:SetVisible(false);
	end


	self.debuffDisplay.Opening =function()
		self.debuffDisplayPanel:SetVisible(true);
		tl,tt=self.debuffDisplayHolder:PointToScreen(self.debuffDisplayHolder:GetPosition());
		self.debuffDisplayLb:SetPosition(246,self.debuffDisplayHolder:GetTop()+21);
		
	end
	
	self.dboHolder = Turbine.UI.Control();
	self.dboHolder:SetSize(420,45);

	self.dboSld = DigitalUtopia.DUInterface.Slider();
	self.dboSld:SetParent(self.dboHolder);
	self.dboSld:SetLeft(57);
	self.dboSld:SetText("Bar Opacity");
	self.sp:AddItem(self.dboHolder);
	
	self.dbiHolder = Turbine.UI.Control();
	self.dbiHolder:SetSize(420,45);

	self.dbiSld = DigitalUtopia.DUInterface.Slider();
	self.dbiSld:SetParent(self.dbiHolder);
	self.dbiSld:SetLeft(57);
	self.dbiSld:SetText("Debuff Indicator Opacity");
	self.sp:AddItem(self.dbiHolder);
	
	self.dbpHolder = Turbine.UI.Control();
	self.dbpHolder:SetSize(420,45);

	self.dbpSld = DigitalUtopia.DUInterface.Slider();
	self.dbpSld:SetParent(self.dbpHolder);
	self.dbpSld:SetLeft(57);
	self.dbpSld:SetText("Vertical Position");
	self.dbpSld:SetMinMax(0,1);
	self.sp:AddItem(self.dbpHolder);
	
	self.cdHdr=Header();
	self.cdHdr.SetText("Cooldowns");
	self.sp:AddItem(self.cdHdr);
	
	self.wndHolder=Turbine.UI.Control();
	self.wndHolder:SetSize(420,30);
	self.wndHolder:SetZOrder(40);
	self.wndHolder:SetMouseVisible(false);
	self.wnd = Turbine.UI.Lotro.TextBox();
	self.wnd:SetParent(self.wndHolder);
	self.wnd:SetPosition(316,0);
	self.wnd:SetSize(89,20);
	self.wnd:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.wnd:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.wnd:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.wnd:SetBlendMode(0);
	self.wnd:SetBackColorBlendMode(0);
	self.wnd:SetMultiline(false);
	self.wnd:SetWantsKeyEvents(true);
	self.wndLabel=Turbine.UI.Label();
	self.wndLabel:SetParent(self.wndHolder);
	self.wndLabel:SetPosition(0,0);
	self.wndLabel:SetSize(315,20);
	self.wndLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.wndLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.wndLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.wndLabel:SetText("Wound Curable Cooldown (In Seconds)");
	self.wnd:SetText("0");
	self.sp:AddItem(self.wndHolder);
	
	self.frHolder=Turbine.UI.Control();
	self.frHolder:SetSize(420,30);
	self.frHolder:SetZOrder(40);
	self.fr = Turbine.UI.Lotro.TextBox();
	self.fr:SetParent(self.frHolder);
	self.fr:SetPosition(316,0);
	self.fr:SetSize(89,20);
	self.fr:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.fr:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.fr:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.fr:SetBlendMode(0);
	self.fr:SetBackColorBlendMode(0);
	self.fr:SetWantsKeyEvents(true);
	self.fr:SetMultiline(false);
	self.frLabel=Turbine.UI.Label();
	self.frLabel:SetParent(self.frHolder);
	self.frLabel:SetPosition(0,0);
	self.frLabel:SetSize(315,20);
	self.frLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.frLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.frLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.frLabel:SetText("Fear Curable Cooldown (In Seconds)");
	self.fr:SetText("0");
	self.sp:AddItem(self.frHolder);
	
	self.disHolder=Turbine.UI.Control();
	self.disHolder:SetSize(420,30);
	self.disHolder:SetZOrder(40);
	self.dis = Turbine.UI.Lotro.TextBox();
	self.dis:SetParent(self.disHolder);
	self.dis:SetPosition(316,0);
	self.dis:SetSize(89,20);
	self.dis:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.dis:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.dis:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.dis:SetBlendMode(0);
	self.dis:SetBackColorBlendMode(0);
	self.dis:SetWantsKeyEvents(true);
	self.dis:SetMultiline(false);
	self.disLabel=Turbine.UI.Label();
	self.disLabel:SetParent(self.disHolder);
	self.disLabel:SetPosition(0,0);
	self.disLabel:SetSize(315,20);
	self.disLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.disLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.disLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.disLabel:SetText("Disease Curable Cooldown (In Seconds)");
	self.dis:SetText("0");
	self.sp:AddItem(self.disHolder);
	
	self.psnHolder=Turbine.UI.Control();
	self.psnHolder:SetSize(420,30);
	self.psnHolder:SetZOrder(40);
	self.psn = Turbine.UI.Lotro.TextBox();
	self.psn:SetParent(self.psnHolder);
	self.psn:SetPosition(316,0);
	self.psn:SetSize(89,20);
	self.psn:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.psn:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.psn:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.psn:SetBlendMode(0);
	self.psn:SetBackColorBlendMode(0);
	self.psn:SetWantsKeyEvents(true);
	self.psn:SetMultiline(false);
	self.psnLabel=Turbine.UI.Label();
	self.psnLabel:SetParent(self.psnHolder);
	self.psnLabel:SetPosition(0,0);
	self.psnLabel:SetSize(315,20);
	self.psnLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.psnLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.psnLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.psnLabel:SetText("Poison Curable Cooldown (In Seconds)");
	self.psn:SetText("0");
	self.sp:AddItem(self.psnHolder);
	
	-- Text Panel--
		self.txw=Turbine.UI.Window();
	self.txw:SetParent(self);
	self.txw:SetSize(575,534);
	self.txw:SetPosition(0,0);
	self.txw:SetMouseVisible(false);
	self.txw:SetVisible(false);
		
		self.sbt = Turbine.UI.Lotro.ScrollBar();
	self.sbt:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.sbt:SetParent(self.txw);
	self.sbt:SetPosition(422,50);
	self.sbt:SetSize(10,448);
	self.sbt:SetZOrder(10);
	self.sbt:SetBackColorBlendMode(0);
	self.sbt:SetBlendMode(0);
	--self.sbt:SetVisible(false);
	
	self.txtPanel=Turbine.UI.ListBox();
	self.txtPanel:SetParent(self.txw);
	self.txtPanel:SetPosition(12,50);
	--self.sp:SetBackColor(Turbine.UI.Color(1,0,0));
	self.txtPanel:SetSize(420,448);
	self.txtPanel:SetVerticalScrollBar(self.sbt);
	--self.sp:SetVisible(false);
	self.txtPanel:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.txtPanel:SetMaxItemsPerLine(1);
	self.txtPanel:SetBackColorBlendMode(0);
	self.txtPanel:SetBlendMode(0);
	--self.txtPanel:SetVisible(false);
	
	self.revText=Turbine.UI.Lotro.Button();
	self.revText:SetParent(self.txw);
	self.revText:SetSize(128,20);
	self.revText:SetText("Revert Text");
	self.revText:SetPosition(32,500);
	self.revText:SetEnabled(false);
	
	self.defText=Turbine.UI.Lotro.Button();
	self.defText:SetParent(self.txw);
	self.defText:SetSize(128,20);
	self.defText:SetText("Default Text");
	self.defText:SetPosition(163,500);
	
	self.accText=Turbine.UI.Lotro.Button();
	self.accText:SetParent(self.txw);
	self.accText:SetSize(128,20);
	self.accText:SetText("Accept");
	self.accText:SetPosition(294,500);
	
	self.pvtHdr=Header();
	self.pvtHdr.SetText("Player Vitals");
	self.txtPanel:AddItem(self.pvtHdr);
	
	self.gTxtPosHolder=Turbine.UI.Control();
	self.gTxtPosHolder:SetSize(420,30);
	
	self.gTxtPos = DigitalUtopia.DUInterface.CheckBox();
	self.gTxtPos:SetChecked(true);
	self.gTxtPos:SetText("Group Text Position");
	self.gTxtPos:SetParent(self.gTxtPosHolder);
	self.gTxtPos:SetLeft(155);
	self.txtPanel:AddItem(self.gTxtPosHolder); 
	
	self.txtPosHolder=Turbine.UI.Control();
	self.txtPosHolder:SetSize(420,30);
	self.txtPos = DigitalUtopia.DUInterface.DropDownBox({"Bottom Outside","Bottom Center","Bottom Inside","Middle Outside","Middle Inside","Top Outside","Top Center","Top Inside"});
	self.txtPos:SetParent(self.txtPosHolder);
	self.txtPos:SetPosition(246,0);
	self.txtPosPanel = Turbine.UI.Window();
	self.txtPosPanel:SetParent(self.txtPanel);
	self.txtPosPanel:SetPosition(0,0);
	self.txtPosPanel:SetSize(480,448);
	self.txtPosPanel:SetZOrder(99);
	self.txtPosPanel:SetVisible(false);
	self.txtPosLb = self.txtPos.listBox; 
	self.txtPosLb:SetParent(self.txtPosPanel);
	self.txtPosLb:SetZOrder(99);
	self.txtPosLb:SetBlendMode(0);
	self.txtPosLb:SetBackColorBlendMode(0);
	self.txtPosLb:SetPosition(200,200);
	self.txtPosLabel=Turbine.UI.Label();
	self.txtPosLabel:SetParent(self.txtPosHolder);
	self.txtPosLabel:SetPosition(0,0);
	self.txtPosLabel:SetSize(246,20);
	self.txtPosLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.txtPosLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.txtPosLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.txtPosLabel:SetText("Vitals Text Position");
	self.txtPanel:AddItem(self.txtPosHolder);
	
	self.txtPosPanel.MouseClick=function(sender,args)
		self.txtPos.Close();
		self.txtPosPanel:SetVisible(false);
	end


	self.txtPos.Opening =function()
		self.txtPosPanel:SetVisible(true);
		self.txtPosLb:SetPosition(246,self.txtPosHolder:GetTop()+21);
		
	end
	
	self.gTxtDisHolder=Turbine.UI.Control();
	self.gTxtDisHolder:SetSize(420,30);
	self.gTxtDis = DigitalUtopia.DUInterface.CheckBox();
	self.gTxtDis:SetChecked(true);
	self.gTxtDis:SetText("Group Text Display");
	self.gTxtDis:SetParent(self.gTxtDisHolder);
	self.gTxtDis:SetLeft(155);
	self.txtPanel:AddItem(self.gTxtDisHolder); 
	
		self.txtDisHolder=Turbine.UI.Control();
	self.txtDisHolder:SetSize(420,30);
	self.txtDis = DigitalUtopia.DUInterface.DropDownBox({"Percentage","Real Numbers","Current/Max","Pct & Current/Max"});
	self.txtDis:SetParent(self.txtDisHolder);
	self.txtDis:SetPosition(246,0);
	self.txtDisPanel = Turbine.UI.Window();
	self.txtDisPanel:SetParent(self.txtPanel);
	self.txtDisPanel:SetPosition(0,0);
	self.txtDisPanel:SetSize(480,448);
	self.txtDisPanel:SetZOrder(99);
	self.txtDisPanel:SetVisible(false);
	self.txtDisLb = self.txtDis.listBox; 
	self.txtDisLb:SetParent(self.txtDisPanel);
	self.txtDisLb:SetZOrder(99);
	self.txtDisLb:SetBlendMode(0);
	self.txtDisLb:SetBackColorBlendMode(0);
	self.txtDisLb:SetPosition(200,200);
	self.txtDisLabel=Turbine.UI.Label();
	self.txtDisLabel:SetParent(self.txtDisHolder);
	self.txtDisLabel:SetPosition(0,0);
	self.txtDisLabel:SetSize(246,20);
	self.txtDisLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.txtDisLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.txtDisLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.txtDisLabel:SetText("Vitals Text Display");
	self.txtPanel:AddItem(self.txtDisHolder);
	
	self.txtDisPanel.MouseClick=function(sender,args)
		self.txtDis.Close();
		self.txtDisPanel:SetVisible(false);
	end


	self.txtDis.Opening =function()
		self.txtDisPanel:SetVisible(true);
		self.txtDisLb:SetPosition(246,self.txtDisHolder:GetTop()+21);
		
	end
	
	self.pmtHdr=Header();
	self.pmtHdr.SetText("Player Morale Bar");
	self.txtPanel:AddItem(self.pmtHdr);
		
	self.pmbTxtPosHolder=Turbine.UI.Control();
	self.pmbTxtPosHolder:SetSize(420,30);
	self.pmbTxtPos = DigitalUtopia.DUInterface.DropDownBox({"Bottom Outside","Bottom Center","Bottom Inside","Middle Outside","Middle Inside","Top Outside","Top Center","Top Inside"});
	self.pmbTxtPos:SetParent(self.pmbTxtPosHolder);
	self.pmbTxtPos:SetPosition(246,0);
	self.pmbTxtPosPanel = Turbine.UI.Window();
	self.pmbTxtPosPanel:SetParent(self.txtPanel);
	self.pmbTxtPosPanel:SetPosition(0,0);
	self.pmbTxtPosPanel:SetSize(480,448);
	self.pmbTxtPosPanel:SetZOrder(99);
	self.pmbTxtPosPanel:SetVisible(false);
	self.pmbTxtPosLb = self.pmbTxtPos.listBox; 
	self.pmbTxtPosLb:SetParent(self.pmbTxtPosPanel);
	self.pmbTxtPosLb:SetZOrder(99);
	self.pmbTxtPosLb:SetBlendMode(0);
	self.pmbTxtPosLb:SetBackColorBlendMode(0);
	self.pmbTxtPosLb:SetPosition(200,200);
	self.pmbTxtPosLabel=Turbine.UI.Label();
	self.pmbTxtPosLabel:SetParent(self.pmbTxtPosHolder);
	self.pmbTxtPosLabel:SetPosition(0,0);
	self.pmbTxtPosLabel:SetSize(246,20);
	self.pmbTxtPosLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbTxtPosLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbTxtPosLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbTxtPosLabel:SetText("Text Position");
	self.txtPanel:AddItem(self.pmbTxtPosHolder);
	
	self.pmbTxtPosPanel.MouseClick=function(sender,args)
		self.pmbTxtPos.Close();
		self.pmbTxtPosPanel:SetVisible(false);
	end


	self.pmbTxtPos.Opening =function()
		self.pmbTxtPosPanel:SetVisible(true);
		self.pmbTxtPosLb:SetPosition(246,self.pmbTxtPosHolder:GetTop()+21);
		
	end
	
		
		self.pmbTxtDisHolder=Turbine.UI.Control();
	self.pmbTxtDisHolder:SetSize(420,30);
	self.pmbTxtDis = DigitalUtopia.DUInterface.DropDownBox({"Percentage","Real Numbers","Current/Max","Pct & Current/Max"});
	self.pmbTxtDis:SetParent(self.pmbTxtDisHolder);
	self.pmbTxtDis:SetPosition(246,0);
	self.pmbTxtDisPanel = Turbine.UI.Window();
	self.pmbTxtDisPanel:SetParent(self.txtPanel);
	self.pmbTxtDisPanel:SetPosition(0,0);
	self.pmbTxtDisPanel:SetSize(480,448);
	self.pmbTxtDisPanel:SetZOrder(99);
	self.pmbTxtDisPanel:SetVisible(false);
	self.pmbTxtDisLb = self.pmbTxtDis.listBox; 
	self.pmbTxtDisLb:SetParent(self.pmbTxtDisPanel);
	self.pmbTxtDisLb:SetZOrder(99);
	self.pmbTxtDisLb:SetBlendMode(0);
	self.pmbTxtDisLb:SetBackColorBlendMode(0);
	self.pmbTxtDisLb:SetPosition(200,200);
	self.pmbTxtDisLabel=Turbine.UI.Label();
	self.pmbTxtDisLabel:SetParent(self.pmbTxtDisHolder);
	self.pmbTxtDisLabel:SetPosition(0,0);
	self.pmbTxtDisLabel:SetSize(246,20);
	self.pmbTxtDisLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbTxtDisLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbTxtDisLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbTxtDisLabel:SetText("Text Display");
	self.txtPanel:AddItem(self.pmbTxtDisHolder);
	
	self.pmbTxtDisPanel.MouseClick=function(sender,args)
		self.pmbTxtDis.Close();
		self.pmbTxtDisPanel:SetVisible(false);
	end


	self.pmbTxtDis.Opening =function()
		self.pmbTxtDisPanel:SetVisible(true);
		self.pmbTxtDisLb:SetPosition(246,self.pmbTxtDisHolder:GetTop()+21);
		
	end
	
	
	self.pptHdr=Header();
	self.pptHdr.SetText("Player Power Bar");
	self.txtPanel:AddItem(self.pptHdr);
		
	self.ppbTxtPosHolder=Turbine.UI.Control();
	self.ppbTxtPosHolder:SetSize(420,30);
	self.ppbTxtPos = DigitalUtopia.DUInterface.DropDownBox({"Bottom Outside","Bottom Center","Bottom Inside","Middle Outside","Middle Inside","Top Outside","Top Center","Top Inside"});
	self.ppbTxtPos:SetParent(self.ppbTxtPosHolder);
	self.ppbTxtPos:SetPosition(246,0);
	self.ppbTxtPosPanel = Turbine.UI.Window();
	self.ppbTxtPosPanel:SetParent(self.txtPanel);
	self.ppbTxtPosPanel:SetPosition(0,0);
	self.ppbTxtPosPanel:SetSize(480,448);
	self.ppbTxtPosPanel:SetZOrder(99);
	self.ppbTxtPosPanel:SetVisible(false);
	self.ppbTxtPosLb = self.ppbTxtPos.listBox; 
	self.ppbTxtPosLb:SetParent(self.ppbTxtPosPanel);
	self.ppbTxtPosLb:SetZOrder(99);
	self.ppbTxtPosLb:SetBlendMode(0);
	self.ppbTxtPosLb:SetBackColorBlendMode(0);
	self.ppbTxtPosLb:SetPosition(200,200);
	self.ppbTxtPosLabel=Turbine.UI.Label();
	self.ppbTxtPosLabel:SetParent(self.ppbTxtPosHolder);
	self.ppbTxtPosLabel:SetPosition(0,0);
	self.ppbTxtPosLabel:SetSize(246,20);
	self.ppbTxtPosLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbTxtPosLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbTxtPosLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbTxtPosLabel:SetText("Text Position");
	self.txtPanel:AddItem(self.ppbTxtPosHolder);
	
	self.ppbTxtPosPanel.MouseClick=function(sender,args)
		self.ppbTxtPos.Close();
		self.ppbTxtPosPanel:SetVisible(false);
	end


	self.ppbTxtPos.Opening =function()
		self.ppbTxtPosPanel:SetVisible(true);
		self.ppbTxtPosLb:SetPosition(246,self.ppbTxtPosHolder:GetTop()+21);
		
	end
	
		
		self.ppbTxtDisHolder=Turbine.UI.Control();
	self.ppbTxtDisHolder:SetSize(420,30);
	self.ppbTxtDis = DigitalUtopia.DUInterface.DropDownBox({"Percentage","Real Numbers","Current/Max","Pct & Current/Max"});
	self.ppbTxtDis:SetParent(self.ppbTxtDisHolder);
	self.ppbTxtDis:SetPosition(246,0);
	self.ppbTxtDisPanel = Turbine.UI.Window();
	self.ppbTxtDisPanel:SetParent(self.txtPanel);
	self.ppbTxtDisPanel:SetPosition(0,0);
	self.ppbTxtDisPanel:SetSize(480,448);
	self.ppbTxtDisPanel:SetZOrder(99);
	self.ppbTxtDisPanel:SetVisible(false);
	self.ppbTxtDisLb = self.ppbTxtDis.listBox; 
	self.ppbTxtDisLb:SetParent(self.ppbTxtDisPanel);
	self.ppbTxtDisLb:SetZOrder(99);
	self.ppbTxtDisLb:SetBlendMode(0);
	self.ppbTxtDisLb:SetBackColorBlendMode(0);
	self.ppbTxtDisLb:SetPosition(200,200);
	self.ppbTxtDisLabel=Turbine.UI.Label();
	self.ppbTxtDisLabel:SetParent(self.ppbTxtDisHolder);
	self.ppbTxtDisLabel:SetPosition(0,0);
	self.ppbTxtDisLabel:SetSize(246,20);
	self.ppbTxtDisLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbTxtDisLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbTxtDisLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbTxtDisLabel:SetText("Text Display");
	self.txtPanel:AddItem(self.ppbTxtDisHolder);
	
	self.ppbTxtDisPanel.MouseClick=function(sender,args)
		self.ppbTxtDis.Close();
		self.ppbTxtDisPanel:SetVisible(false);
	end


	self.ppbTxtDis.Opening =function()
		self.ppbTxtDisPanel:SetVisible(true);
		self.ppbTxtDisLb:SetPosition(246,self.ppbTxtDisHolder:GetTop()+21);
		
	end
	
	
	self.pmbBcChanged=function()
                             
	end                          
	
	self.pmbClrOneChanged=function()
                             
	end
	
	self.pmbClrTwoChanged=function()
                             
	end
	
	self.ppbBcChanged=function()
                             
	end                          
	
	self.ppbClrOneChanged=function()
                             
	end
	
	self.ppbClrTwoChanged=function()
                             
	end
	
	-- Color Panel--
		self.clw=Turbine.UI.Window();
	self.clw:SetParent(self);
	self.clw:SetSize(575,534);
	self.clw:SetPosition(0,0);
	self.clw:SetMouseVisible(false);
	self.clw:SetVisible(false);
	
	self.sbc = Turbine.UI.Lotro.ScrollBar();
	self.sbc:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.sbc:SetParent(self.clw);
	self.sbc:SetPosition(422,50);
	self.sbc:SetSize(10,448);
	self.sbc:SetZOrder(10);
	self.sbc:SetBackColorBlendMode(0);
	self.sbc:SetBlendMode(0);
	--self.sbc:SetVisible(false);
	
	self.colPanel=Turbine.UI.ListBox();
	self.colPanel:SetParent(self.clw);
	self.colPanel:SetPosition(12,50);
	--self.sp:SetBackColor(Turbine.UI.Color(1,0,0));
	self.colPanel:SetSize(420,448);
	self.colPanel:SetVerticalScrollBar(self.sbc);
	--self.sp:SetVisible(false);
	self.colPanel:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.colPanel:SetMaxItemsPerLine(1);
	self.colPanel:SetBackColorBlendMode(0);
	self.colPanel:SetBlendMode(0);
	--self.colPanel:SetVisible(false);
	
	self.revColor=Turbine.UI.Lotro.Button();
	self.revColor:SetParent(self.clw);
	self.revColor:SetSize(128,20);
	self.revColor:SetText("Revert Color");
	self.revColor:SetPosition(32,500);
	self.revColor:SetEnabled(false);
	
	self.defColor=Turbine.UI.Lotro.Button();
	self.defColor:SetParent(self.clw);
	self.defColor:SetSize(128,20);
	self.defColor:SetText("Default Color");
	self.defColor:SetPosition(163,500);
	
	self.accColor=Turbine.UI.Lotro.Button();
	self.accColor:SetParent(self.clw);
	self.accColor:SetSize(128,20);
	self.accColor:SetText("Accept");
	self.accColor:SetPosition(294,500);
	
	self.pmbcHdr=Header();
	self.pmbcHdr.SetText("Player Morale Bar");
	self.colPanel:AddItem(self.pmbcHdr);

	self.pmbBcHolder=Turbine.UI.Control();
	self.pmbBcHolder:SetSize(420,35);
	self.pmbBcLabel=Turbine.UI.Label();
	self.pmbBcLabel:SetParent(self.pmbBcHolder);
	self.pmbBcLabel:SetPosition(0,0);
	self.pmbBcLabel:SetSize(246,35);
	self.pmbBcLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbBcLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbBcLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbBcLabel:SetText("Bar Color");
	self.pmbBcColor=Turbine.UI.Lotro.TextBox();
	self.pmbBcColor:SetParent(self.pmbBcHolder);
	self.pmbBcColor:SetSize(35,25);
	self.pmbBcColor:SetPosition(265,5);
	self.pmbBcColor:SetReadOnly(true);
	self.pmbBcCp=DigitalUtopia.DUInterface.ColorPicker();
	self.pmbBcCp:SetParent(self.pmbBcHolder);
	self.pmbBcCp:SetPosition(305,5);
	self.pmbBcOL=Turbine.UI.Control();
	self.pmbBcOL:SetParent(self.pmbBcColor);
	self.pmbBcOL:SetSize(30,20);
	self.pmbBcOL:SetZOrder(5);
	self.pmbBcOL:SetPosition(2,2);
	self.pmbBcOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.colPanel:AddItem(self.pmbBcHolder);
	self.pmbBcCp.ColorChanged=function(sender,args)
		self.pmbBcOL:SetBackColor(args.Color);
		self.pmbBcChanged();
	end
	
	
	
	
	
	self.pmbEceHolder=Turbine.UI.Control();
	self.pmbEceHolder:SetSize(420,30);
	
	self.pmbEce = DigitalUtopia.DUInterface.CheckBox();
	self.pmbEce:SetChecked(true);
	self.pmbEce:SetText("Enable Color Effects");
	self.pmbEce:SetParent(self.pmbEceHolder);
	self.pmbEce:SetLeft(155);
	self.colPanel:AddItem(self.pmbEceHolder); 
	
	self.pmbEctHolder=Turbine.UI.Control();
	self.pmbEctHolder:SetSize(420,30);
	
	self.pmbEct = DigitalUtopia.DUInterface.CheckBox();
	self.pmbEct:SetChecked(true);
	self.pmbEct:SetText("Enable Color Transitions");
	self.pmbEct:SetParent(self.pmbEctHolder);
	self.pmbEct:SetLeft(155);
	self.colPanel:AddItem(self.pmbEctHolder); 
	
	self.pmbClrOneHolder=Turbine.UI.Control();
	self.pmbClrOneHolder:SetSize(420,35);
	self.pmbClrOneHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.pmbClrOneLabel=Turbine.UI.Label();
	self.pmbClrOneLabel:SetParent(self.pmbClrOneHolder);
	self.pmbClrOneLabel:SetPosition(0,0);
	self.pmbClrOneLabel:SetSize(246,35);
	self.pmbClrOneLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbClrOneLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbClrOneLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbClrOneLabel:SetText("Point #1 Color");
	self.pmbClrOneColor=Turbine.UI.Lotro.TextBox();
	self.pmbClrOneColor:SetParent(self.pmbClrOneHolder);
	self.pmbClrOneColor:SetSize(35,25);
	self.pmbClrOneColor:SetPosition(265,5);
	self.pmbClrOneColor:SetReadOnly(true);
	self.pmbClrOneCp=DigitalUtopia.DUInterface.ColorPicker();
	self.pmbClrOneCp:SetParent(self.pmbClrOneHolder);
	self.pmbClrOneCp:SetPosition(305,5);
	self.pmbClrOneOL=Turbine.UI.Control();
	self.pmbClrOneOL:SetParent(self.pmbClrOneColor);
	self.pmbClrOneOL:SetSize(30,20);
	self.pmbClrOneOL:SetZOrder(5);
	self.pmbClrOneOL:SetPosition(2,2);
	self.pmbClrOneOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.colPanel:AddItem(self.pmbClrOneHolder);
	self.pmbClrOneCp.ColorChanged=function(sender,args)
		self.pmbClrOneOL:SetBackColor(args.Color);
		self.pmbClrOneChanged();
	end
	
	self.pmbCpOneHolder = Turbine.UI.Control();
	self.pmbCpOneHolder:SetSize(420,45);
	self.pmbCpOneHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.pmbCpOneSld = DigitalUtopia.DUInterface.Slider();
	self.pmbCpOneSld:SetStep(0.01);
	self.pmbCpOneSld:SetParent(self.pmbCpOneHolder);
	self.pmbCpOneSld:SetLeft(57);
	self.pmbCpOneSld:SetText("Point #1 Location");
	self.colPanel:AddItem(self.pmbCpOneHolder);
	
	self.pmbEscHolder=Turbine.UI.Control();
	self.pmbEscHolder:SetSize(420,30);
	
	self.pmbEsc = DigitalUtopia.DUInterface.CheckBox();
	self.pmbEsc:SetChecked(true);
	self.pmbEsc:SetText("Enable 2nd Color");
	self.pmbEsc:SetParent(self.pmbEscHolder);
	self.pmbEsc:SetLeft(155);
	self.colPanel:AddItem(self.pmbEscHolder); 
	
			self.pmbClrTwoHolder=Turbine.UI.Control();
	self.pmbClrTwoHolder:SetSize(420,35);
	self.pmbClrTwoHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.pmbClrTwoLabel=Turbine.UI.Label();
	self.pmbClrTwoLabel:SetParent(self.pmbClrTwoHolder);
	self.pmbClrTwoLabel:SetPosition(0,0);
	self.pmbClrTwoLabel:SetSize(246,35);
	self.pmbClrTwoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbClrTwoLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbClrTwoLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbClrTwoLabel:SetText("Point #2 Color");
	self.pmbClrTwoColor=Turbine.UI.Lotro.TextBox();
	self.pmbClrTwoColor:SetParent(self.pmbClrTwoHolder);
	self.pmbClrTwoColor:SetSize(35,25);
	self.pmbClrTwoColor:SetPosition(265,5);
	self.pmbClrTwoColor:SetReadOnly(true);
	self.pmbClrTwoCp=DigitalUtopia.DUInterface.ColorPicker();
	self.pmbClrTwoCp:SetParent(self.pmbClrTwoHolder);
	self.pmbClrTwoCp:SetPosition(305,5);
	self.pmbClrTwoOL=Turbine.UI.Control();
	self.pmbClrTwoOL:SetParent(self.pmbClrTwoColor);
	self.pmbClrTwoOL:SetSize(30,20);
	self.pmbClrTwoOL:SetZOrder(5);
	self.pmbClrTwoOL:SetPosition(2,2);
	self.pmbClrTwoOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.colPanel:AddItem(self.pmbClrTwoHolder);
	self.pmbClrTwoCp.ColorChanged=function(sender,args)
		self.pmbClrTwoOL:SetBackColor(args.Color);
		self.pmbClrTwoChanged();
	end
	
	self.pmbCpTwoHolder = Turbine.UI.Control();
	self.pmbCpTwoHolder:SetSize(420,45);
	self.pmbCpTwoHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.pmbCpTwoSld = DigitalUtopia.DUInterface.Slider();
	self.pmbCpTwoSld:SetStep(0.01);
	self.pmbCpTwoSld:SetParent(self.pmbCpTwoHolder);
	self.pmbCpTwoSld:SetLeft(57);
	self.pmbCpTwoSld:SetText("Point #2 Location");
	self.colPanel:AddItem(self.pmbCpTwoHolder);
	
	
	self.ppbcHdr=Header();
	self.ppbcHdr.SetText("Player Power Bar");
	self.colPanel:AddItem(self.ppbcHdr);
	
	self.ppbBcHolder=Turbine.UI.Control();
	self.ppbBcHolder:SetSize(420,35);
	self.ppbBcLabel=Turbine.UI.Label();
	self.ppbBcLabel:SetParent(self.ppbBcHolder);
	self.ppbBcLabel:SetPosition(0,0);
	self.ppbBcLabel:SetSize(246,35);
	self.ppbBcLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbBcLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbBcLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbBcLabel:SetText("Bar Color");
	self.ppbBcColor=Turbine.UI.Lotro.TextBox();
	self.ppbBcColor:SetParent(self.ppbBcHolder);
	self.ppbBcColor:SetSize(35,25);
	self.ppbBcColor:SetPosition(265,5);
	self.ppbBcColor:SetReadOnly(true);
	self.ppbBcCp=DigitalUtopia.DUInterface.ColorPicker();
	self.ppbBcCp:SetParent(self.ppbBcHolder);
	self.ppbBcCp:SetPosition(305,5);
	self.ppbBcOL=Turbine.UI.Control();
	self.ppbBcOL:SetParent(self.ppbBcColor);
	self.ppbBcOL:SetSize(30,20);
	self.ppbBcOL:SetZOrder(5);
	self.ppbBcOL:SetPosition(2,2);
	self.ppbBcOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.colPanel:AddItem(self.ppbBcHolder);
	self.ppbBcCp.ColorChanged=function(sender,args)
		self.ppbBcOL:SetBackColor(args.Color);
		self.ppbBcChanged();
	end
	
	
	self.ppbEceHolder=Turbine.UI.Control();
	self.ppbEceHolder:SetSize(420,30);
	
	self.ppbEce = DigitalUtopia.DUInterface.CheckBox();
	self.ppbEce:SetChecked(true);
	self.ppbEce:SetText("Enable Color Effects");
	self.ppbEce:SetParent(self.ppbEceHolder);
	self.ppbEce:SetLeft(155);
	self.colPanel:AddItem(self.ppbEceHolder); 
	
	self.ppbEctHolder=Turbine.UI.Control();
	self.ppbEctHolder:SetSize(420,30);
	
	self.ppbEct = DigitalUtopia.DUInterface.CheckBox();
	self.ppbEct:SetChecked(true);
	self.ppbEct:SetText("Enable Color Transitions");
	self.ppbEct:SetParent(self.ppbEctHolder);
	self.ppbEct:SetLeft(155);
	self.colPanel:AddItem(self.ppbEctHolder); 
	
	self.ppbClrOneHolder=Turbine.UI.Control();
	self.ppbClrOneHolder:SetSize(420,35);
	self.ppbClrOneLabel=Turbine.UI.Label();
	self.ppbClrOneLabel:SetParent(self.ppbClrOneHolder);
	self.ppbClrOneLabel:SetPosition(0,0);
	self.ppbClrOneLabel:SetSize(246,35);
	self.ppbClrOneLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbClrOneLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbClrOneLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbClrOneLabel:SetText("Point #1 Color");
	self.ppbClrOneColor=Turbine.UI.Lotro.TextBox();
	self.ppbClrOneColor:SetParent(self.ppbClrOneHolder);
	self.ppbClrOneColor:SetSize(35,25);
	self.ppbClrOneColor:SetPosition(265,5);
	self.ppbClrOneColor:SetReadOnly(true);
	self.ppbClrOneCp=DigitalUtopia.DUInterface.ColorPicker();
	self.ppbClrOneCp:SetParent(self.ppbClrOneHolder);
	self.ppbClrOneCp:SetPosition(305,5);
	self.ppbClrOneOL=Turbine.UI.Control();
	self.ppbClrOneOL:SetParent(self.ppbClrOneColor);
	self.ppbClrOneOL:SetSize(30,20);
	self.ppbClrOneOL:SetZOrder(5);
	self.ppbClrOneOL:SetPosition(2,2);
	self.ppbClrOneOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.colPanel:AddItem(self.ppbClrOneHolder);
	self.ppbClrOneCp.ColorChanged=function(sender,args)
		self.ppbClrOneOL:SetBackColor(args.Color);
		self.ppbClrOneChanged();
	end
	
	self.ppbCpOneHolder = Turbine.UI.Control();
	self.ppbCpOneHolder:SetSize(420,45);

	self.ppbCpOneSld = DigitalUtopia.DUInterface.Slider();
	self.ppbCpOneSld:SetStep(0.01);
	self.ppbCpOneSld:SetParent(self.ppbCpOneHolder);
	self.ppbCpOneSld:SetLeft(57);
	self.ppbCpOneSld:SetText("Point #1 Location");
	self.colPanel:AddItem(self.ppbCpOneHolder);
	
	self.ppbEscHolder=Turbine.UI.Control();
	self.ppbEscHolder:SetSize(420,30);
	
	self.ppbEsc = DigitalUtopia.DUInterface.CheckBox();
	self.ppbEsc:SetChecked(true);
	self.ppbEsc:SetText("Enable 2nd Color");
	self.ppbEsc:SetParent(self.ppbEscHolder);
	self.ppbEsc:SetLeft(155);
	self.colPanel:AddItem(self.ppbEscHolder); 
	
			self.ppbClrTwoHolder=Turbine.UI.Control();
	self.ppbClrTwoHolder:SetSize(420,35);
	self.ppbClrTwoLabel=Turbine.UI.Label();
	self.ppbClrTwoLabel:SetParent(self.ppbClrTwoHolder);
	self.ppbClrTwoLabel:SetPosition(0,0);
	self.ppbClrTwoLabel:SetSize(246,35);
	self.ppbClrTwoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbClrTwoLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbClrTwoLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbClrTwoLabel:SetText("Point #2 Color");
	self.ppbClrTwoColor=Turbine.UI.Lotro.TextBox();
	self.ppbClrTwoColor:SetParent(self.ppbClrTwoHolder);
	self.ppbClrTwoColor:SetSize(35,25);
	self.ppbClrTwoColor:SetPosition(265,5);
	self.ppbClrTwoColor:SetReadOnly(true);
	self.ppbClrTwoCp=DigitalUtopia.DUInterface.ColorPicker();
	self.ppbClrTwoCp:SetParent(self.ppbClrTwoHolder);
	self.ppbClrTwoCp:SetPosition(305,5);
	self.ppbClrTwoOL=Turbine.UI.Control();
	self.ppbClrTwoOL:SetParent(self.ppbClrTwoColor);
	self.ppbClrTwoOL:SetSize(30,20);
	self.ppbClrTwoOL:SetZOrder(5);
	self.ppbClrTwoOL:SetPosition(2,2);
	self.ppbClrTwoOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.colPanel:AddItem(self.ppbClrTwoHolder);
	self.ppbClrTwoCp.ColorChanged=function(sender,args)
		self.ppbClrTwoOL:SetBackColor(args.Color);
		self.ppbClrTwoChanged();
	end
	
	self.ppbCpTwoHolder = Turbine.UI.Control();
	self.ppbCpTwoHolder:SetSize(420,45);

	self.ppbCpTwoSld = DigitalUtopia.DUInterface.Slider();
	self.ppbCpTwoSld:SetStep(0.01);
	self.ppbCpTwoSld:SetParent(self.ppbCpTwoHolder);
	self.ppbCpTwoSld:SetLeft(57);
	self.ppbCpTwoSld:SetText("Point #2 Location");
	self.colPanel:AddItem(self.ppbCpTwoHolder);
	
	self.setupPanel = Turbine.UI.Window();
	self.setupPanel:SetParent(self);
	self.setupPanel:SetSize(140,507);
	self.setupPanel:SetBackground("DigitalUtopia/Palantir/Resources/Options_menu_side_bar.tga");
	self.setupPanel:SetPosition(self:GetWidth()-143,20);
	self.setupPanel:SetMouseVisible(false);
	self.alertHolder=Turbine.UI.Window();
	self.alertHolder:SetVisible(false);
	--self.alertHolder:SetMouseVisible(false);
	self.alertHolder:SetSize(Turbine.UI.Display:GetWidth(),Turbine.UI.Display:GetHeight());
	--self.alertHolder:SetBackColor(Turbine.UI.Color(.01,0,0,0));
	self.alertHolder:SetZOrder(99);
	self.alert=DigitalUtopia.DUInterface.BaseWindow(512,172);
	self.alert:SetParent(self.alertHolder);
	self.alert:SetPosition((Turbine.UI.Display:GetWidth()-self.alert:GetWidth())/2,(Turbine.UI.Display:GetHeight()-self.alert:GetHeight())/2);
	self.alert:SetZOrder(99);
	self.alertText=Turbine.UI.Label();
	self.alertText:SetParent(self.alert);
	self.alertText:SetSize(512,20);
	self.alertText:SetForeColor(Turbine.UI.Color(210/255,255/255,0/255));
	self.alertText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.alertText:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.alertText:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.alertText:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.alertText:SetText(" Are you sure you want to restore the default settings?");
	self.alertText:SetPosition(0,54);
	self.alertYes=Turbine.UI.Lotro.Button();
	self.alertYes:SetParent(self.alert);
	self.alertYes:SetText("Yes");
	self.alertYes:SetSize(106,20);
	self.alertYes:SetPosition(144,141);
	self.alertNo=Turbine.UI.Lotro.Button();
	self.alertNo:SetParent(self.alert);
	self.alertNo:SetText("No");
	self.alertNo:SetSize(106,20);
	self.alertNo:SetPosition(263,141);
	self.nocPanel.MouseClick=function(sender,args)
		self.noc.Close();
		self.nocPanel:SetVisible(false);
	end


	self.noc.Opening =function()
		self.nocPanel:SetVisible(true);
		tl,tt=self.nocHolder:PointToScreen(self.nocHolder:GetPosition());
		self.nocLb:SetPosition(246,self.nocHolder:GetTop()+21);
		
	end
	
		self.acPanel.MouseClick=function(sender,args)
		self.ac.Close();
		self.acPanel:SetVisible(false);
	end


	self.ac.Opening =function()
		self.acPanel:SetVisible(true);
		tl,tt=self.acHolder:PointToScreen(self.acHolder:GetPosition());
		self.acLb:SetPosition(246,self.acHolder:GetTop()+21);
		
	end
	
	self.gen = ToggleButton();
	self.gen:SetParent(self.setupPanel);
	self.gen:SetPosition(7,100);
	self.gen.SetToggle(1);
	self.gen.SetText("Main");
	

	
	self.col = ToggleButton();
	self.col:SetParent(self.setupPanel);
	self.col:SetPosition(7,125);
	self.col.SetText("Color");	
	

	self.txt = ToggleButton();
	self.txt:SetParent(self.setupPanel);
	self.txt:SetPosition(7,150);
	self.txt.SetText("Text");
	
	self.gen.Click=function()
		self.tw:SetVisible(true);
		self.col.SetToggle(0);
		self.clw:SetVisible(false);
		self.txt.SetToggle(0);
		self.txw:SetVisible(false);
	end
	
	self.col.Click=function()
		self.clw:SetVisible(true);
		self.gen.SetToggle(0);
		self.tw:SetVisible(false);
		self.txt.SetToggle(0);
		self.txw:SetVisible(false);
	end
	
	self.txt.Click=function()
		self.txw:SetVisible(true);
		self.gen.SetToggle(0);
		self.tw:SetVisible(false);
		self.col.SetToggle(0);
		self.clw:SetVisible(false);
	end
	
	
	self.showSetup = function()
		
	end
	
	self.closeSetup = function()
	
	end
end